#ifndef BINTREE_H
#define BINTREE_H
#include <iostream.h>
#include "Unit1.h"

template <class Type>
class BinaryTree {
public:
  struct TreeNode {
    Type Element;
    TreeNode *Left, *Right;
    TreeNode() : Left(0), Right(0) {}
    TreeNode(Type Item, TreeNode * LeftNode = 0, TreeNode * RightNode = 0) :
      Element(Item), Left(LeftNode), Right(RightNode) {}
  };
protected:
  TreeNode * Root;
  Type RefValue;
  bool Insert(TreeNode * &Tree, const Type & Item);
  bool Search(TreeNode * &Tree, const Type & Item);
public:
  BinaryTree() : Root(0) {}
  BinaryTree(Type aRefValue) : RefValue(aRefValue), Root(0) {}
  virtual ~BinaryTree() {}
  virtual bool Insert(const Type & Item);
  bool Search(const Type & Item);
};

template <class Type>
  bool BinaryTree<Type>::Insert(TreeNode * &Tree, const Type & Item)
{
  if (Tree == 0) {
    Tree = new TreeNode(Item);
    return Tree ? TRUE : FALSE;
    }
  else if (Item < Tree->Element)
    return Insert(Tree->Left, Item);
  else
    return Insert(Tree->Right, Item);
}

template <class Type>
  bool BinaryTree<Type>::Search(TreeNode * &Tree, const Type &Item)
{
  if (Tree) {
    if (Tree->Element == Item)
      return true;
    else if (Item < Tree->Element)
      return Search(Tree->Left, Item);
    else
      return Search(Tree->Right, Item);
  }
  return false;
}

template <class Type>
  bool BinaryTree<Type>::Insert(const Type & Item)
{
  return Insert(Root, Item);
}

template <class Type>
  bool BinaryTree<Type>::Search(const Type & Item) {
  return Search(Root, Item);
}

#endif
